////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Ghost_Mask2.fx ver0.0.5  }XN摜쐬CKpȊÕf
//  ( Ghost.fx Ăяo܂DItXN[`p)
//  쐬: jP( ͉Pfull.fx )
//
////////////////////////////////////////////////////////////////////////////////////////////////

// Wϊs
float4x4 WorldViewProjMatrix : WORLDVIEWPROJECTION;

// }eAF
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
float4 EdgeColor       : EDGECOLOR;

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};


////////////////////////////////////////////////////////////////////////////////////////////////

// _VF[_
float4 VS_Mask(float4 Pos : POSITION) : POSITION
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

////////////////////////////////////////////////////////////////////////////////////////////////
// ֊s`

//sNZVF[_
float4 PS_EdgeMask() : COLOR {
    float alpha = EdgeColor.a;
    return float4(alpha, alpha, alpha, 0.01); // ]ĐώẐ
}

//GbW`
technique EdgeTec < string MMDPass = "edge"; > {
    pass DrawMask {
        AlphaBlendEnable = TRUE;
        SrcBlend = ZERO;
        DestBlend = INVSRCCOLOR;
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_EdgeMask();
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`

//sNZVF[_(߂l)
float4 PS_ObjectMask(float2 Tex : TEXCOORD0, uniform bool useTexture) : COLOR
{
    float alpha = MaterialDiffuse.a;

    if ( useTexture ) {
        // eNX`ߒlKp
        alpha *= tex2D( ObjTexSampler, Tex ).a;
    }

    return float4(alpha, alpha, alpha, 0.01); // ]ĐώẐ
}

//ZtVhEȂ
technique Mask0 < string MMDPass = "object"; bool UseTexture = false; > {
    pass DrawMask {
        AlphaBlendEnable = TRUE;
        SrcBlend = ZERO;
        DestBlend = INVSRCCOLOR;
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_ObjectMask(false);
    }
}

technique Mask1 < string MMDPass = "object"; bool UseTexture = true; > {
    pass DrawMask {
        AlphaBlendEnable = TRUE;
        SrcBlend = ZERO;
        DestBlend = INVSRCCOLOR;
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_ObjectMask(true);
    }
}

//ZtVhE
technique MaskSS0 < string MMDPass = "object_ss"; bool UseTexture = false; > {
    pass DrawMask {
        AlphaBlendEnable = TRUE;
        SrcBlend = ZERO;
        DestBlend = INVSRCCOLOR;
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_ObjectMask(false);
    }
}

technique MaskSS1 < string MMDPass = "object_ss"; bool UseTexture = true; > {
    pass DrawMask {
        AlphaBlendEnable = TRUE;
        SrcBlend = ZERO;
        DestBlend = INVSRCCOLOR;
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_ObjectMask(true);
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////

//nʉe͕`悵Ȃ
technique ShadowTec < string MMDPass = "shadow"; > { }

