////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Hologram.fx ver0.0.2  f̃zO\
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
// ̃p[^ύXĂ
float HeightMin = 0.0;  // tF[hJn
float HeightMax = 20.0; // tF[hI
float Threshold = 0.5;  // tF[h臒l(lƃtF[h̕ωV[vő傫ƃ}ChɂȂ܂)

#define NoiseTexFile "Stripe2.png"  // ȃmCYeNX`,Stripe0.png:mCYȂ, Stripe1.png:mCY, Stripe2.png:mCY
float StripeThick = 0.3;   // ȑ
float NoiseSpeed = 27.0;   // mCYx
float NoiseDens = 2.0;     // mCYx
float GaussianVal = 1.5;   // ɂݓx
float3 LightColor = {0.0, 0.7, 0.5}; // F

// f̃ItXN[_
texture HologramRT: OFFSCREENRENDERTARGET <
    string Description = "OffScreen RenderTarget for Hologram.fx";
    float2 ViewPortRatio = {1.0,1.0};
    float4 ClearColor = { 0, 0, 0, 0 };
    float ClearDepth = 1.0;
    bool AntiAlias = true;
    string DefaultEffect = 
        "self = hide;"
//********** ɓKpIuWFNgw肵Ă **********

        "~N.pmd = none;"
        "negi.x = none;"

//********************************************************************
        "* = hide;";
>;
// f̃}XNɎgItXN[obt@
texture MaskHologramRT : OFFSCREENRENDERTARGET <
    string Description = "OffScreen RenderTarget for Mask of Hologram.fx";
    float2 ViewPortRatio = {1.0,1.0};
    float4 ClearColor = { 0, 0, 0, 1 };
    float ClearDepth = 1.0;
    string Format="A32B32G32R32F";
    bool AntiAlias = false;
    int Miplevels = 1;
    string DefaultEffect = 
        "self = hide;"
//**** ɓKpIuWFNgw肵Ă(KƓfI) ****

        "~N.pmd = Hologram_Mask1.fx;"
        "negi.x = Hologram_Mask1.fx;"

//**********************************************************************************
        "* = Hologram_Mask2.fx;" 
    ;
>;


// Ȃl͂牺͂Ȃł

///////////////////////////////////////////////////////////////////////////////////////////////
sampler HologramView = sampler_state {
    texture = <HologramRT>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

sampler MaskHologram = sampler_state {
    texture = <MaskHologramRT>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};


// Ag[eNX`(~bv}bv)
texture2D screen_tex1 <
    string ResourceName = NoiseTexFile;
    int MipLevels = 0;
>;
sampler TexSampler1 = sampler_state {
    texture = <screen_tex1>;
    MinFilter = ANISOTROPIC;
    MagFilter = ANISOTROPIC;
    MipFilter = LINEAR;
    MaxAnisotropy = 5;
    AddressU  = WRAP;
    AddressV = WRAP;
};

float time : Time;

// ANZTp[^
float3 AcsPos : CONTROLOBJECT < string name = "(self)"; string item = "XYZ"; >;
float AcsSi : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float AcsTr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
static float AcsHmin = AcsPos.x + HeightMin; 
static float AcsHmax = AcsPos.y + HeightMax; 
static float AcsGain = saturate(1.0f - AcsPos.z) * GaussianVal; 
static float AcsScaling = AcsSi*0.1f; 
static float AcsAlpha = AcsTr;

// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(2,2)/ViewportSize*AcsGain);

// ڂ̏d݌WF
//    KEX֐ exp( -x^2/(2*d^2) )  d=5, x=0`7 ɂČvẐA
//    (WT_7 + WT_6 + c + WT_1 + WT_0 + WT_1 + c + WT_7)  1 ɂȂ悤ɐK
#define  WT_0  0.0920246
#define  WT_1  0.0902024
#define  WT_2  0.0849494
#define  WT_3  0.0768654
#define  WT_4  0.0668236
#define  WT_5  0.0558158
#define  WT_6  0.0447932
#define  WT_7  0.0345379

// _O^[Qbg̃NAl
float4 ClearColor = float4(1.0f, 1.0f, 1.0f, 0.0f);
float ClearDepth  = 1.0f;

// IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0, 1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0, 1.0};
    string Format = "D24S8";
>;

// X̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0, 1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp2 = sampler_state {
    texture = <ScnMap2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
   float4 Pos  : POSITION;
   float2 Tex  : TEXCOORD0;
};

// ʂ̒_VF[_
VS_OUTPUT VS_Common(float4 Pos : POSITION, float4 Tex : TEXCOORD0)
{
    VS_OUTPUT Out = (VS_OUTPUT)0; 

    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;

    return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// `

float4 PS_Light(float2 Tex: TEXCOORD0) : COLOR
{
    // ItXN[obt@̐F
    float4 Color = tex2D(MaskHologram, Tex);
    float alpha = Color.r * 0.8;
    float height = Color.g;

    Color.rgb = LightColor * alpha;
//    Color.rgb *= tex2D(HologramView, Tex).rgb;
    Color.a = 1.0f;

    // tF[hߒlvZ
    float v = 1.0f-saturate( ( height - AcsHmin ) / ( AcsHmax - AcsHmin ) );
    float a = (1.0+Threshold)*AcsScaling - 0.5f*Threshold;
    float minLen = a - 0.5f*Threshold;
    float maxLen = a + 0.5f*Threshold;
    Color.rgb *= AcsAlpha*saturate( (maxLen - v)/(maxLen - minLen) );

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Xڂ

VS_OUTPUT VS_passX( float4 Pos : POSITION, float4 Tex : TEXCOORD0 )
{
    VS_OUTPUT Out = (VS_OUTPUT)0; 

    Out.Pos = Pos;
    Out.Tex = Tex + float2(0, ViewportOffset.y);

    return Out;
}

float4 PS_passX( float2 Tex: TEXCOORD0 ) : COLOR
{
    float4 Color;

    Color  = WT_0 *   tex2D( ScnSamp, Tex );
    Color += WT_1 * ( tex2D( ScnSamp, Tex+float2(SampStep.x  ,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x  ,0) ) );
    Color += WT_2 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*2,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*2,0) ) );
    Color += WT_3 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*3,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*3,0) ) );
    Color += WT_4 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*4,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*4,0) ) );
    Color += WT_5 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*5,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*5,0) ) );
    Color += WT_6 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*6,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*6,0) ) );
    Color += WT_7 * ( tex2D( ScnSamp, Tex+float2(SampStep.x*7,0) ) + tex2D( ScnSamp, Tex-float2(SampStep.x*7,0) ) );

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// Yڂ

VS_OUTPUT VS_passY( float4 Pos : POSITION, float4 Tex : TEXCOORD0 )
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    Out.Pos = Pos;
    Out.Tex = Tex + float2(ViewportOffset.x, 0);

    return Out;
}

float4 PS_passY(float2 Tex: TEXCOORD0) : COLOR
{
    float4 Color;

    Color  = WT_0 *   tex2D( ScnSamp2, Tex );
    Color += WT_1 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y  ) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y  ) ) );
    Color += WT_2 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*2) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*2) ) );
    Color += WT_3 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*3) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*3) ) );
    Color += WT_4 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*4) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*4) ) );
    Color += WT_5 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*5) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*5) ) );
    Color += WT_6 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*6) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*6) ) );
    Color += WT_7 * ( tex2D( ScnSamp2, Tex+float2(0,SampStep.y*7) ) + tex2D( ScnSamp2, Tex-float2(0,SampStep.y*7) ) );

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
//zO`

float4 PS_Hologram(float2 Tex: TEXCOORD0) : COLOR
{
    // ItXN[obt@̐F
    float4 Color = tex2D(HologramView, Tex);
    float4 Color2 = tex2D(MaskHologram, Tex);

    float height = Color2.g;

    // mCY
    if(NoiseSpeed > 0.0001f){
       float ah = 50.0f*frac(NoiseSpeed*time);
       float ax = smoothstep(-NoiseDens, NoiseDens, abs(height-ah));
       Color = tex2D(HologramView, float2(Tex.x+3.0f*(1.0f-ax)*SampStep.x, Tex.y));
       Color.a *= ax;
       Color.a *= lerp(0.8f, 1.0f, abs(0.6f*sin(35 * 7*time + 13) + 0.4f*cos(73 * 7*time + 17)));
    }

    // ȓ
    float rand = 0.6f*sin(37 * time + 13) + 0.4f*cos(71 * time + 17);
    Color.a *= Color2.r;
    Color.a *= tex2D(TexSampler1, float2((Tex.x+rand)*StripeThick*Color2.b, Tex.y*StripeThick*Color2.b))*1.2f;
    Color.a = saturate(Color.a);

    // tF[hߒlvZ
    float v = 1.0f-saturate( ( height - AcsHmin ) / ( AcsHmax - AcsHmin ) );
    float a = (1.0+Threshold)*AcsScaling - 0.5f*Threshold;
    float minLen = a - 0.5f*Threshold;
    float maxLen = a + 0.5f*Threshold;
    Color.a *= AcsAlpha*saturate( (maxLen - v)/(maxLen - minLen) );

    return Color;
}

// `
float4 PS_HologramLight(float2 Tex: TEXCOORD0) : COLOR
{
    float4 Color = tex2D(ScnSamp, Tex);
    Color.a *= saturate(1.0f - AcsPos.z);
    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
//eNjbN

technique MainTec<
    string Script = 
        "RenderColorTarget0=ScnMap;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "Pass=LightSource;"
        "RenderColorTarget0=ScnMap2;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "Pass=Gaussian_X;"
        "RenderColorTarget0=ScnMap;"
	    "RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
	    "Pass=Gaussian_Y;"
        "RenderColorTarget0=;"
	    "RenderDepthStencilTarget=;"
	    "Pass=DrawObject;"
	    "Pass=DrawLight;"
    ;
> {
    pass LightSource < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_Common();
        PixelShader  = compile ps_2_0 PS_Light();
    }
    pass Gaussian_X < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_passX();
        PixelShader  = compile ps_2_0 PS_passX();
    }
    pass Gaussian_Y < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_passY();
        PixelShader  = compile ps_2_0 PS_passY();
    }
    pass DrawObject < string Script= "Draw=Buffer;"; > {
        VertexShader = compile vs_2_0 VS_Common();
        PixelShader  = compile ps_2_0 PS_Hologram();
    }
    pass DrawLight < string Script= "Draw=Buffer;"; > {
        ALPHABLENDENABLE = TRUE;
        SRCBLEND=ONE;
        DESTBLEND=ONE;
        VertexShader = compile vs_2_0 VS_Common();
        PixelShader  = compile ps_2_0 PS_HologramLight();
    }

}
////////////////////////////////////////////////////////////////////////////////////////////////



