////////////////////////////////////////////////////////////////////////////////////////////////
//
//  FloorLightArt.fx ver0.0.1 ɃCgG`ē܂DXe[Wop
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
// ̃p[^ύXĂ
#define TexFile  "sample.png" // IuWFNgɓ\eNX`t@C
int TexTypeCount = 4;         // eNX`ސ
float TexChangeTime = 10.0;   // eNX`ύXԊԊu(b)

int UnitCount = 7;            // `IuWFNg
float UnitSize = 1.0;         // `TCY
float RotRadius = 15.0;       // ω]a
float LocalRotSpeed = 0.2;    // [J]x(cycle/b)
float GlobalRotSpeed = 0.1;   // Ӊ]x(cycle/b)
float RadiusRange = 0.4;      // OړU(RotRadiusƂ̔)
float IOMoveFreq = 18.0;      // Oړ(b)
float Distortion = 0.0;       // ]ɕω^p[^
float zAdjust = 0.0;          // nʉeƏdȂĂꍇ̕␳l
float InitAlpha = 0.3;        // Tr=1̎̓ߓx
float3 LightColor = {1.0, 1.0, 0.7}; // eNX`̏ZF(RBG)

// Ȃl͂牺͂Ȃł

////////////////////////////////////////////////////////////////////////////////////////////////
// p[^錾

float AcsTr  : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;

float time : TIME;

#define PAI 3.14159265f   // 

int Index;

// Wϊs
float4x4 ViewProjMatrix  : VIEWPROJECTION;
float4x4 WorldMatrix     : WORLD;
float4x4 ViewMatrix      : VIEW;

texture2D ParticleTex <
    string ResourceName = TexFile;
>;
sampler ParticleSamp = sampler_state {
    texture = <ParticleTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV  = CLAMP;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

////////////////////////////////////////////////////////////////////////////////////////////////
// W2D]
float3 Rotation2D(float3 pos, float rot)
{
    float x = pos.x * cos(rot) - pos.z * sin(rot);
    float z = pos.x * sin(rot) + pos.z * cos(rot);

    return float3(x, pos.y, z);
}

///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`

struct VS_OUTPUT {
   float4 Pos   : POSITION;    // ˉeϊW
   float2 Tex   : TEXCOORD1;   // eNX`
   float4 Color : COLOR0;      // ZF
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float2 Tex : TEXCOORD0)
{
   VS_OUTPUT Out = (VS_OUTPUT)0;

   // [hWϊ
   Pos.xyz = mul( Pos.xyz, (float3x3)WorldMatrix );

   // IuWFNgTCY
   Pos.x *= 8.0f * UnitSize;
   Pos.z *= 8.0f * UnitSize;
   Pos.y += zAdjust + 0.005f*Index; // dȂĂȂ߂̕␳

   // IuWFNg[J]
   Pos.xyz = Rotation2D(Pos.xyz, time*LocalRotSpeed*2.0f*PAI);

   // IuWFNgӉ]
   Pos.z += RotRadius * (1.0f + RadiusRange * clamp( sin(time*2.0f*PAI/IOMoveFreq)+0.3f, -0.5f, 0.5f) * 2.0f );
   Pos.xyz = Rotation2D(Pos.xyz,  (time*GlobalRotSpeed + (float)Index/(float)UnitCount)*2.0f*PAI );

   // IuWFNg]̕ω
   float3 pos = float3(0.0f, 0.0f, Distortion);
   Pos.xyz += Rotation2D(pos, ((float)Index/(float)UnitCount)*2.0f*PAI);

   // J_̃r[ˉeϊ
   Pos.xyz += WorldMatrix._41_42_43;
   Out.Pos = mul( Pos, ViewProjMatrix );

   // eNX`W
   float LType = (float)floor( (time/TexChangeTime) % (float)TexTypeCount );
   Tex.x = (Tex.x +  LType) / (float)TexTypeCount;
   Out.Tex = Tex;

   // eNX`̏ZF
   float a = (0.5f - abs( frac( time / TexChangeTime ) - 0.5f) ) * TexChangeTime;
   Out.Color = float4( LightColor*smoothstep( 0.0f, 1.0f, a )*AcsTr, 1.0f);

   return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN) : COLOR0
{
   float4 Color = tex2D( ParticleSamp, IN.Tex );
   Color.rgb *= InitAlpha;
   Color *= IN.Color;
   return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// eNjbN
technique MainTec0 < string MMDPass = "object";
    string Script = "LoopByCount=UnitCount;"
                    "LoopGetIndex=Index;"
                    "Pass=DrawObject;"
                    "LoopEnd=;"; >
{
   pass DrawObject {
      AlphaBlendEnable = TRUE;
      SrcBlend = ONE;
      DestBlend = ONE;
      VertexShader = compile vs_2_0 Basic_VS();
      PixelShader  = compile ps_2_0 Basic_PS();
   }
}




