////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Hologram_Mask1.fx ver0.0.2  }XN摜쐬CKpf𔒂
//  ( Hologram.fx Ăяo܂DItXN[`p)
//  쐬: jP( ͉Pfull.fx )
//
////////////////////////////////////////////////////////////////////////////////////////////////

float3 BoneCenter : CONTROLOBJECT < string name = "(self)"; string item = "Z^["; >;
float3 AcsOffset : CONTROLOBJECT < string name = "(self)"; >;

// Wϊs
float4x4 WorldMatrix      : WORLD;
float4x4 ProjMatrix       : PROJECTION;
float4x4 ViewProjMatrix   : VIEWPROJECTION;

float3 CameraPosition   : POSITION  < string Object = "Camera"; >;
static float PmdEyeLength = max( length( CameraPosition - BoneCenter ), 10.0f ) * pow(2.4142f / ProjMatrix._22, 0.7f);;
static float AcsEyeLength = max( length( CameraPosition - AcsOffset ), 10.0f ) * pow(2.4142f / ProjMatrix._22, 0.7f);;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

////////////////////////////////////////////////////////////////////////////////////////////////

struct VS_OUTPUT {
    float4 Pos  : POSITION;    // ˉeϊW
    float4 VPos : TEXCOORD1;   // [hϊW
};

// _VF[_
VS_OUTPUT VS_Mask(float4 Pos : POSITION)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    // [hWϊ
    Pos = mul( Pos, WorldMatrix );
    Out.VPos = Pos;

    // J_̃r[ˉeϊ
    Out.Pos = mul( Pos, ViewProjMatrix );

    return Out;
}

//sNZVF[_
float4 PS_PmdMask(VS_OUTPUT IN) : COLOR
{
    float height = IN.VPos.y/IN.VPos.w;
    return float4(1.0f, height, min(PmdEyeLength, 40.0f), 1.0f);
}

float4 PS_AcsMask(VS_OUTPUT IN) : COLOR
{
    float height = IN.VPos.y/IN.VPos.w;
    return float4(1.0f, height, min(AcsEyeLength, 40.0f), 1.0f);
}

//////////////////////////////////////////////////////////////////////////////////
// eNjbN

technique EdgeTec < string MMDPass = "edge"; > {
    pass DrawMask {
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_PmdMask();
    }
}

//ZtVhEȂ
technique Mask < string MMDPass = "object"; bool UseToon = false; > {
    pass DrawMask {
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_AcsMask();
    }
}

technique Mask < string MMDPass = "object"; bool UseToon = true; > {
    pass DrawMask {
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_PmdMask();
    }
}

//ZtVhE
technique MaskSS < string MMDPass = "object_ss"; bool UseToon = false; > {
    pass DrawMask {
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_AcsMask();
    }
}

technique MaskSS < string MMDPass = "object_ss"; bool UseToon = true; > {
    pass DrawMask {
        VertexShader = compile vs_2_0 VS_Mask();
        PixelShader  = compile ps_2_0 PS_PmdMask();
    }
}

//`悵Ȃ
technique ShadowTec < string MMDPass = "shadow"; > { }
technique ZplotTec < string MMDPass = "zplot"; > { }

